package dev.shadowsoffire.apotheosis.adventure.affix.augmenting;

import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.network.chat.Style;
import dev.shadowsoffire.apotheosis.adventure.client.DropDownList;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Font;
import java.util.Iterator;
import net.minecraft.client.StringSplitter;
import net.minecraft.network.chat.CommonComponents;
import java.util.Collection;
import java.util.Comparator;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import java.util.stream.Collector;
import java.util.Set;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.stream.Stream;
import java.util.ArrayList;
import net.minecraft.client.gui.screens.inventory.tooltip.DefaultTooltipPositioner;
import java.util.stream.Collectors;
import com.google.common.collect.Lists;
import net.minecraft.client.gui.screens.inventory.tooltip.ClientTooltipComponent;
import java.util.function.Function;
import java.util.Objects;
import net.minecraft.locale.Language;
import net.minecraft.client.gui.screens.inventory.tooltip.TooltipRenderUtil;
import net.minecraft.util.FormattedCharSequence;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.ChatFormatting;
import net.minecraft.client.gui.components.events.GuiEventListener;
import java.util.Collections;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Inventory;
import dev.shadowsoffire.apotheosis.adventure.client.SimpleTexButton;
import net.minecraft.network.chat.FormattedText;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureContainerScreen;

public class AugmentingScreen extends AdventureContainerScreen<AugmentingMenu>
{
    public static final ResourceLocation TEXTURE;
    public static final int ALTERNATIVE_TEXT_WIDTH = 150;
    public static final int ALTERNATIVE_MAX_LINES = 15;
    protected ItemStack lastMainItem;
    protected int lastSelection;
    protected List<AffixInstance> currentItemAffixes;
    protected int alternativePage;
    protected List<List<FormattedText>> alternativePages;
    protected int alternativeXPos;
    protected int alternativeWidth;
    protected AffixDropList list;
    protected SimpleTexButton upgradeBtn;
    protected SimpleTexButton rerollBtn;
    
    public AugmentingScreen(final AugmentingMenu pMenu, final Inventory pPlayerInventory, final Component pTitle) {
        super((AbstractContainerMenu)pMenu, pPlayerInventory, pTitle);
        this.lastMainItem = ItemStack.f_41583_;
        this.lastSelection = -1;
        this.currentItemAffixes = Collections.emptyList();
        this.alternativePage = -1;
        this.alternativePages = Collections.emptyList();
        this.alternativeXPos = 0;
        this.alternativeWidth = 0;
        this.f_97727_ = 222;
    }
    
    protected void m_7856_() {
        super.m_7856_();
        final int left = this.getGuiLeft();
        final int top = this.getGuiTop();
        final int selected = this.getSelectedAffix();
        (this.list = (AffixDropList)this.m_142416_((GuiEventListener)new AffixDropList(left + 39, top + 17, 123, 14, (Component)Component.m_237119_(), this.currentItemAffixes, 6))).setSelected(selected);
        final Component sigilName = (Component)Component.m_237115_("item.apotheosis.sigil_of_enhancement").m_130940_(ChatFormatting.YELLOW);
        this.upgradeBtn = (SimpleTexButton)this.m_142416_((GuiEventListener)new FatTexButton(left + 60, top + 111, 29, 13, 186, 135, btn -> {
            if (this.getSelectedAffix() != -1) {
                this.f_96541_.f_91072_.m_105208_(((AugmentingMenu)this.f_97732_).f_38840_, 0x0 | this.getSelectedAffix() << 1);
            }
        }, (Component)Component.m_237115_("button.apotheosis.augmenting.upgrade"), (Component)Component.m_237110_("button.apotheosis.augmenting.upgrade.cost", new Object[] { 2, sigilName })));
        this.rerollBtn = (SimpleTexButton)this.m_142416_((GuiEventListener)new FatTexButton(left + 112, top + 111, 29, 13, 223, 135, btn -> {
            if (this.getSelectedAffix() != -1) {
                this.f_96541_.f_91072_.m_105208_(((AugmentingMenu)this.f_97732_).f_38840_, 0x1 | this.getSelectedAffix() << 1);
            }
        }, (Component)Component.m_237115_("button.apotheosis.augmenting.reroll"), (Component)Component.m_237110_("button.apotheosis.augmenting.upgrade.cost", new Object[] { 1, sigilName })));
    }
    
    protected void m_7286_(final GuiGraphics gfx, final float partialTick, final int mouseX, final int mouseY) {
        this.updateCachedState();
        final int left = this.getGuiLeft();
        final int top = this.getGuiTop();
        final int xCenter = (this.f_96543_ - this.f_97726_) / 2;
        final int yCenter = (this.f_96544_ - this.f_97727_) / 2;
        gfx.m_280163_(AugmentingScreen.TEXTURE, xCenter, yCenter, 0.0f, 0.0f, this.f_97726_, this.f_97727_, 256, 307);
        final int selected = this.getSelectedAffix();
        if (selected != -1 && !this.list.isOpen()) {
            final AffixInstance inst = this.currentItemAffixes.get(selected);
            final Component comp = inst.getAugmentingText();
            final List<FormattedCharSequence> split = this.f_96547_.m_92923_((FormattedText)comp, 117);
            for (int i = 0; i < split.size(); ++i) {
                gfx.m_280649_(this.f_96547_, (FormattedCharSequence)split.get(i), left + 43, top + 40 + i * 11, (int)ChatFormatting.YELLOW.m_126665_(), true);
            }
            final int bgColor = -267386864;
            final int borderColor = -13220529;
            TooltipRenderUtil.renderTooltipBackground(gfx, left + 42, top + 39, 117, 65, 0, bgColor, bgColor, borderColor, borderColor);
        }
        else {
            final int bgColor2 = -1441787888;
            final int borderColor2 = -1439283889;
            TooltipRenderUtil.renderTooltipBackground(gfx, left + 42, top + 39, 117, 65, 0, bgColor2, bgColor2, borderColor2, borderColor2);
        }
        if (selected != -1 && this.rerollBtn.m_274382_() && this.rerollBtn.m_142518_() && this.alternativePage != -1) {
            final List<FormattedText> page = this.alternativePages.get(this.alternativePage);
            final Stream<Object> stream = page.stream();
            final Language 128107_ = Language.m_128107_();
            Objects.requireNonNull(128107_);
            final List<ClientTooltipComponent> list = stream.map((Function<? super Object, ?>)128107_::m_5536_).map((Function<? super Object, ?>)ClientTooltipComponent::m_169948_).collect(Collectors.toCollection(Lists::newArrayList));
            if (this.alternativePages.size() > 1) {
                list.set(list.size() - 2, (ClientTooltipComponent)new FakeWidthComponent(this.alternativeWidth));
            }
            gfx.m_280497_(this.f_96547_, (List)list, this.alternativeXPos, this.getGuiTop() + 33, DefaultTooltipPositioner.f_262752_);
        }
        if (selected != -1 && this.upgradeBtn.m_142518_() && this.upgradeBtn.m_274382_()) {
            final AffixInstance inst = this.currentItemAffixes.get(selected);
            final AffixInstance upgraded = new AffixInstance(inst.affix(), inst.stack(), inst.rarity(), Math.min(1.0f, inst.level() + 0.25f));
            final List<Component> altText = new ArrayList<Component>();
            altText.add((Component)Component.m_237115_("text.apotheosis.upgraded_form").m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE }));
            altText.add((Component)Component.m_237110_("%s", new Object[] { upgraded.getAugmentingText() }).m_130940_(ChatFormatting.YELLOW));
            this.drawOnLeft(gfx, (List)altText, top + 33, 150);
        }
    }
    
    protected void updateCachedState() {
        final ItemStack mainItem = ((AugmentingMenu)this.f_97732_).getMainItem();
        if (!ItemStack.m_150942_(mainItem, this.lastMainItem)) {
            final List<AffixInstance> newAffixes = AugmentingMenu.computeItemAffixes(mainItem);
            if (ItemStack.m_41656_(mainItem, this.lastMainItem) && this.currentItemAffixes.size() == newAffixes.size()) {
                this.list.setEntries((List)newAffixes);
                this.list.setSelected(this.lastSelection);
            }
            else {
                this.list.setEntries((List)newAffixes);
            }
            this.currentItemAffixes = newAffixes;
            this.lastMainItem = mainItem.m_41777_();
            this.computeAlternatives(this.list.getSelected());
        }
        if (this.lastSelection != this.list.getSelected()) {
            this.computeAlternatives(this.lastSelection = this.list.getSelected());
        }
        final int selected = this.getSelectedAffix();
        if (selected == -1) {
            final Component comp = (Component)Component.m_237115_("button.apotheosis.augmenting.no_selection").m_130940_(ChatFormatting.RED);
            this.upgradeBtn.f_93623_ = false;
            this.upgradeBtn.setInactiveMessage(comp);
            this.rerollBtn.f_93623_ = false;
            this.rerollBtn.setInactiveMessage(comp);
        }
        else {
            this.upgradeBtn.f_93623_ = true;
            this.rerollBtn.f_93623_ = true;
            final AffixInstance current = this.currentItemAffixes.get(selected);
            if (current.level() >= 1.0f) {
                this.upgradeBtn.f_93623_ = false;
                this.upgradeBtn.setInactiveMessage((Component)Component.m_237115_("button.apotheosis.augmenting.max_level").m_130940_(ChatFormatting.RED));
            }
            if (this.alternativePages.isEmpty()) {
                this.rerollBtn.f_93623_ = false;
                this.rerollBtn.setInactiveMessage((Component)Component.m_237115_("button.apotheosis.augmenting.no_alternatives").m_130940_(ChatFormatting.RED));
            }
            if (this.upgradeBtn.m_142518_() && ((AugmentingMenu)this.f_97732_).getSigils().m_41613_() < 2 && !((AugmentingMenu)this.f_97732_).player.m_7500_()) {
                this.upgradeBtn.f_93623_ = false;
                this.upgradeBtn.setInactiveMessage((Component)Component.m_237115_("Not Enough Sigils").m_130940_(ChatFormatting.RED));
            }
            if (this.rerollBtn.m_142518_() && ((AugmentingMenu)this.f_97732_).getSigils().m_41613_() < 1 && !((AugmentingMenu)this.f_97732_).player.m_7500_()) {
                this.rerollBtn.f_93623_ = false;
                this.rerollBtn.setInactiveMessage((Component)Component.m_237115_("Not Enough Sigils").m_130940_(ChatFormatting.RED));
            }
        }
    }
    
    protected void computeAlternatives(final int selected) {
        if (selected == -1) {
            this.alternativePages = Collections.emptyList();
            this.alternativePage = -1;
            return;
        }
        final AffixInstance current = this.currentItemAffixes.get(selected);
        final List<DynamicHolder<? extends Affix>> alternatives = LootController.getAvailableAffixes(this.lastMainItem, (LootRarity)current.rarity().get(), (Set)this.currentItemAffixes.stream().map((Function<? super Object, ?>)AffixInstance::affix).collect((Collector<? super Object, ?, Set<? super Object>>)Collectors.toSet()), ((Affix)current.affix().get()).getType());
        if (alternatives.isEmpty()) {
            this.alternativePages = Collections.emptyList();
            this.alternativePage = -1;
        }
        else {
            final StringSplitter splitter = this.f_96547_.m_92865_();
            int maxWidth = 0;
            final Component heading = (Component)Component.m_237115_("text.apotheosis.potential_rerolls").m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE });
            final List<List<FormattedText>> pages = new ArrayList<List<FormattedText>>();
            List<FormattedText> page = new ArrayList<FormattedText>();
            page.add((FormattedText)heading);
            boolean first = true;
            for (final DynamicHolder<? extends Affix> afx : alternatives) {
                final Component augTxt = ((Affix)afx.get()).getAugmentingText(current.stack(), (LootRarity)current.rarity().get(), current.level());
                final List<FormattedText> split = splitter.m_92414_((FormattedText)Component.m_237110_("%s", new Object[] { augTxt }).m_130940_(ChatFormatting.YELLOW), 150, augTxt.m_7383_());
                final int a = maxWidth;
                final Stream<Object> stream = split.stream();
                final Font f_96547_ = this.ths().f_96547_;
                Objects.requireNonNull(f_96547_);
                maxWidth = Math.max(a, stream.map((Function<? super Object, ?>)f_96547_::m_92852_).max((Comparator<? super Integer>)Integer::compare).get());
                if (page.size() + split.size() + 1 > 15) {
                    pages.add(page);
                    page = new ArrayList<FormattedText>();
                    page.add((FormattedText)heading);
                    page.addAll(split);
                }
                else {
                    if (!first) {
                        page.add((FormattedText)CommonComponents.f_263701_);
                    }
                    page.addAll(split);
                    first = false;
                }
                if (afx == alternatives.get(alternatives.size() - 1)) {
                    pages.add(page);
                }
            }
            this.alternativePage = 0;
            this.alternativePages = pages;
            this.alternativeXPos = this.ths().getGuiLeft() - 16 - maxWidth;
            this.alternativeWidth = maxWidth;
            final int pages2 = this.alternativePages.size();
            if (pages2 > 1) {
                for (int i = 0; i < pages2; ++i) {
                    final List<FormattedText> page2 = this.alternativePages.get(i);
                    page2.add((FormattedText)CommonComponents.f_263701_);
                    page2.add((FormattedText)Component.m_237110_("text.apotheosis.alternative_page", new Object[] { i + 1, pages2 }).m_130940_(ChatFormatting.DARK_GRAY));
                }
            }
        }
    }
    
    protected int getSelectedAffix() {
        return (this.list == null) ? -1 : this.list.getSelected();
    }
    
    public static void handleRerollResult(final DynamicHolder<? extends Affix> newAffix) {
        final Screen f_91080_ = Minecraft.m_91087_().f_91080_;
        if (f_91080_ instanceof final AugmentingScreen scn) {
            scn.updateCachedState();
            for (int i = 0; i < scn.currentItemAffixes.size(); ++i) {
                final AffixInstance inst = scn.currentItemAffixes.get(i);
                if (inst.affix().equals((Object)newAffix)) {
                    scn.list.setSelected(i);
                    return;
                }
            }
        }
    }
    
    static {
        TEXTURE = new ResourceLocation("apotheosis", "textures/gui/augmenting.png");
    }
    
    public class AffixDropList extends DropDownList<AffixInstance>
    {
        public AffixDropList(final int x, final int y, final int width, final int height, final Component narrationMsg, final List<AffixInstance> entries, final int maxDisplayedEntries) {
            super(x, y, width, height, narrationMsg, (List)entries, maxDisplayedEntries);
        }
        
        protected void m_87963_(final GuiGraphics gfx, final int mouseX, final int mouseY, final float partialTick) {
            gfx.m_280168_().m_85836_();
            gfx.m_280168_().m_252880_(0.0f, 0.0f, 100.0f);
            if (this.entries.isEmpty()) {
                gfx.m_280163_(AugmentingScreen.TEXTURE, this.m_252754_(), this.m_252907_(), 0.0f, 267.0f, this.f_93618_, this.baseHeight, 256, 307);
            }
            super.m_87963_(gfx, mouseX, mouseY, partialTick);
            final int hovered = this.getHoveredSlot((double)mouseX, (double)mouseY);
            if (this.isOpen && hovered != -1) {
                final AffixInstance inst = this.entries.get(hovered);
                final List<Component> list = new ArrayList<Component>();
                list.add((Component)inst.getName(true).m_6881_().m_130948_(Style.f_131099_.m_178520_(16777088).m_131162_(Boolean.valueOf(true))));
                list.add((Component)Component.m_237110_("%s", new Object[] { inst.getAugmentingText() }).m_130940_(ChatFormatting.YELLOW));
                AugmentingScreen.this.drawOnLeft(gfx, (List)list, AugmentingScreen.this.getGuiTop() + 33, 150);
            }
            gfx.m_280163_(AugmentingScreen.TEXTURE, this.m_252754_() + this.f_93618_ - 15, this.m_252907_(), (float)(123 + (this.isOpen ? 15 : 0)), 239.0f, 15, 14, 256, 307);
            gfx.m_280168_().m_85849_();
        }
        
        protected void renderEntry(final GuiGraphics gfx, final int x, final int y, final int mouseX, final int mouseY, final AffixInstance entry) {
            final int hovered = this.getHoveredSlot((double)mouseX, (double)mouseY);
            final int idx = this.entries.indexOf(entry);
            gfx.m_280163_(AugmentingScreen.TEXTURE, x, y, 0.0f, (float)(239 + ((hovered == idx) ? this.baseHeight : 0)), this.f_93618_, this.baseHeight, 256, 307);
            gfx.m_280430_(AugmentingScreen.this.f_96547_, entry.getName(true), x + 2, y + 3, 16777088);
        }
    }
    
    public class FatTexButton extends SimpleTexButton
    {
        protected final Component costMsg;
        
        public FatTexButton(final int x, final int y, final int width, final int height, final int u, final int v, final Button.OnPress press, final Component message, final Component costMsg) {
            super(x, y, width, height, u, v, AugmentingScreen.TEXTURE, 256, 307, press, message);
            this.costMsg = costMsg;
        }
        
        public void m_87963_(final GuiGraphics gfx, final int pMouseX, final int pMouseY, final float pPartialTick) {
            int yTex = this.yTexStart - 2;
            if (!this.m_142518_()) {
                yTex += this.f_93619_ + 4;
            }
            else if (this.m_274382_()) {
                yTex += (this.f_93619_ + 4) * 2;
            }
            RenderSystem.enableDepthTest();
            RenderSystem.enableBlend();
            gfx.m_280163_(this.texture, this.m_252754_() - 2, this.m_252907_() - 2, (float)(this.xTexStart - 2), (float)yTex, this.f_93618_ + 4, this.f_93619_ + 4, this.textureWidth, this.textureHeight);
            if (this.m_274382_()) {
                this.renderToolTip(gfx, pMouseX, pMouseY);
            }
        }
        
        public void renderToolTip(final GuiGraphics gfx, final int pMouseX, final int pMouseY) {
            if (this.m_6035_() != CommonComponents.f_237098_ && this.m_274382_()) {
                Component primary = this.m_6035_();
                if (!this.f_93623_) {
                    primary = (Component)primary.m_6881_().m_130940_(ChatFormatting.GRAY);
                }
                final List<Component> tooltips = new ArrayList<Component>();
                tooltips.add(primary);
                if (this.m_142518_()) {
                    tooltips.add(this.costMsg);
                }
                else if (this.inactiveMessage != CommonComponents.f_237098_) {
                    tooltips.add(this.inactiveMessage);
                }
                gfx.m_280666_(Minecraft.m_91087_().f_91062_, (List)tooltips, pMouseX, pMouseY);
            }
        }
        
        public boolean m_6050_(final double pMouseX, final double pMouseY, final double pDelta) {
            if (this == AugmentingScreen.this.rerollBtn && this.m_142518_() && this.m_274382_()) {
                final int change = (pDelta < 0.0) ? 1 : -1;
                int page = AugmentingScreen.this.alternativePage;
                page = Math.floorMod(page + change, AugmentingScreen.this.alternativePages.size());
                AugmentingScreen.this.alternativePage = page;
                return true;
            }
            return super.m_6050_(pMouseX, pMouseY, pDelta);
        }
    }
    
    record FakeWidthComponent(int width) implements ClientTooltipComponent {
        public int m_142103_() {
            return 9;
        }
        
        public int m_142069_(final Font pFont) {
            return this.width;
        }
    }
}
